<?php

 
/**
 * bp_component_register_widgets()
 *
 * This function will register your widgets so that they will show up on the widget list
 * for site administrators to drop into their widget zones.
 */
function rt_media_register_widgets() {
	global $current_blog;
	/* Site welcome widget */
    wp_register_sidebar_widget( 'buddypress-example', __( 'Recently Added Pictures', 'rt-media' ), 'rt_media_widget_cool_widget');
    wp_register_widget_control( 'buddypress-example', __( 'Recently Added Pictures', 'rt-media' ), 'rt_media_widget_cool_widget_control' );

    wp_register_sidebar_widget( 'buddypress-example-video', __( 'Recently Added Videos', 'rt-media' ), 'rt_media_widget_cool_widget_video');
    wp_register_widget_control( 'buddypress-example-video', __( 'Recently Added Videos', 'rt-media' ), 'rt_media_widget_cool_widget_control_video' );


	/* Include the javascript and /or CSS needed for activated widgets only. If none needed, this code can be left out. */
	if ( is_active_widget( 'rt_media_widget_cool_widget' ) ) {
		wp_enqueue_script( 'rt_media_widget_cool_widget-js', WP_PLUGIN_URL . '/rt-bp-kaltura-plugin/js/widget-example.js', array('jquery', 'jquery-livequery-pack') );
		wp_enqueue_style( 'rt_media_widget_cool_widget-css', WP_PLUGIN_URL . '/rt-bp-kaltura-plugin/css/widget-example.css' );
	}

        if ( is_active_widget( 'rt_media_widget_cool_widget-video' ) ) {
		wp_enqueue_script( 'rt_media_widget_cool_widget-js', WP_PLUGIN_URL . '/rt-bp-kaltura-plugin/js/widget-example.js', array('jquery', 'jquery-livequery-pack') );
		wp_enqueue_style( 'rt_media_widget_cool_widget-css', WP_PLUGIN_URL . '/rt-bp-kaltura-plugin/css/widget-example.css' );
	}

}
add_action( 'plugins_loaded', 'rt_media_register_widgets' );

/**
 * rt_media_widget_cool_widget()
 *
 * This function controls the actual HTML output of the widget. This is where you will
 * want to query whatever you need, and render the actual output.
 */
function rt_media_widget_cool_widget($args) {
    global $current_blog, $bp,$wpdb,$current_user,$bp;
    extract($args);
	/***
	 * This is where you'll want to fetch the widget settings and use them to modify the
	 * widget's output.
	 */
	$options = get_blog_option( $current_blog->blog_id, 'rt_media_widget_cool_widget' );
?>
	<?php echo $before_widget; ?>
	<?php echo $before_title
		. $widget_name 
		. $after_title; ?>

	<?php

    $query = "SELECT * FROM wp_bp_rt_media WHERE rt_content_type=2 order by rt_created_at desc limit 0,$options[max_events]";
    $result = $wpdb->get_results($query);
    $rt_user_uploaded_photo_count = count($result);
    $partner_id     = get_site_option('bp_rt_kaltura_partner_id');
    $subp_id        = $partner_id."00"; //kaltura says sub partner id is = partnerID * 100;
    $secret         = get_site_option('bp_rt_kaltura_secret');
    $admin_secret   = get_site_option('bp_rt_kaltura_admin_secret');

    //define session variables
    $partnerUserID    = 'ANONYMOUS';

    //construct Kaltura objects for session initiation
    $kaltura_url = get_site_option('bp_rt_kaltura_url');

    $config           = new KalturaConfiguration($partner_id);
    $config->serviceUrl = $kaltura_url;

    $client           = new KalturaClient($config);

    $ks               = $client->session->start($admin_secret, $partnerUserID, KalturaSessionType::ADMIN);
    $client->setKs($ks);  // set the session in the client
    
    $filter = new KalturaMediaEntryFilter();
    $filter->statusEqual = KalturaEntryStatus::READY;
    $filter->mediaTypeEqual = KalturaMediaType::IMAGE;

    $pager = new KalturaFilterPager();
    $pager->pageSize = 10;
    $pager->pageIndex = 1;
    $list = $client->media->listAction($filter); // list all of the media items in the partner
    $count = count($list->objects);
	?>
    <?php
    for($i=0;$i<$count;$i++) {
        for($j=0;$j<$rt_user_uploaded_photo_count;$j++) {
            if($list->objects[$i]->id == $result[$j]->rt_content_id){
             ?>
                    <?php $url_to_album = get_option('siteurl')."/members/".get_userdata($result[$j]->rt_user_id)->user_login."/media/photo/";?>
                    <a href="<?php echo $url_to_album?>" title="">
                        <img src="<?php echo $list->objects[$i]->thumbnailUrl?>" alt="Thumb" />
                    </a>
	<?php
	
            }
        }
    }
	/***
	 * This is where you add your HTML and render what you want your widget to display.
	 */
	?>

	<?php echo $after_widget; ?>
<?php
}

/**
 * rt_media_widget_cool_widget_control()
 *
 * This function will enable a "edit" menu on your widget. This lets site admins click
 * the edit link on the widget to set options. The options you can then use in the display of 
 * your widget.
 *
 * For example, in the groups component widget there is a setting called "max-groups" where
 * a user can define how many groups they would like to display.
 */
function rt_media_widget_cool_widget_control() {
	global $current_blog;
	
	$options = $newoptions = get_blog_option( $current_blog->blog_id, 'rt_media_widget_cool_widget');

	if ( $_POST['rt-bp-kaltura-widget-cool-widget'] ) {
		$newoptions['option_name'] = strip_tags( stripslashes( $_POST['rt-bp-kaltura-widget-cool-widget-option'] ) );
	}
	
	if ( $options != $newoptions ) {
		$options = $newoptions;
		update_blog_option( $current_blog->blog_id, 'rt_media_widget_cool_widget', $options );
	}
?>
<p>
    <label for="rt-bp-kaltura-widget-cool-widget-option">
            <?php _e( 'Max number of Picuters to show:1', 'rt-bp-kaltura' ); ?><br />
        <input class="widefat" id="rt-bp-kaltura-widget-cool-widget-option" name="rt-bp-kaltura-widget-cool-widget-option" type="text" value="<?php echo attribute_escape( $options['option_name'] ); ?>" style="width: 30%" />
    </label>
</p>
	<input type="hidden" id="rt-bp-kaltura-widget-cool-widget" name="rt-bp-kaltura-widget-cool-widget" value="1" />

<?php
}

        /**
 * rt_media_widget_cool_widget_video()
 *
 * This function controls the actual HTML output of the widget. This is where you will
 * want to query whatever you need, and render the actual output.
 */
function rt_media_widget_cool_widget_video($args) {
    global $current_blog, $bp,$wpdb,$current_user,$bp;
    extract($args);
	/***
	 * This is where you'll want to fetch the widget settings and use them to modify the
	 * widget's output.
	 */
	$options = get_blog_option( $current_blog->blog_id, 'rt_media_widget_cool_widget_video' );
?>
	<?php echo $before_widget; ?>
	<?php echo $before_title
		. $widget_name
		. $after_title; ?>

	<?php

    $query = "SELECT * FROM wp_bp_rt_media WHERE rt_content_type=1 order by rt_created_at desc limit 0,$options[max_events]";
//    var_dump($query);
    $result = $wpdb->get_results($query);
    $rt_user_uploaded_video_count = count($result);
    $partner_id     = get_site_option('bp_rt_kaltura_partner_id');
    $subp_id        = $partner_id."00"; //kaltura says sub partner id is = partnerID * 100;
    $secret         = get_site_option('bp_rt_kaltura_secret');
    $admin_secret   = get_site_option('bp_rt_kaltura_admin_secret');

    //define session variables
    $partnerUserID    = 'ANONYMOUS';

    //construct Kaltura objects for session initiation
    $kaltura_url = get_site_option('bp_rt_kaltura_url');

    $config           = new KalturaConfiguration($partner_id);
    $config->serviceUrl = $kaltura_url;

    $client           = new KalturaClient($config);

    $ks               = $client->session->start($admin_secret, $partnerUserID, KalturaSessionType::ADMIN);
    $client->setKs($ks);  // set the session in the client
//    var_dump($ks);
    $filter = new KalturaMediaEntryFilter();
    $filter->statusEqual = KalturaEntryStatus::READY;
    $filter->mediaTypeEqual = KalturaMediaType::VIDEO;

    $pager = new KalturaFilterPager();
    $pager->pageSize = 10;
    $pager->pageIndex = 1;
    $list = $client->media->listAction($filter); // list all of the media items in the partner
//    var_dump($list);
    $count = count($list->objects);
    for($i=0;$i<$count;$i++) {
        for($j=0;$j<$rt_user_uploaded_video_count;$j++) {
            if($list->objects[$i]->id == $result[$j]->rt_content_id){
             ?>
                    <?php $url_to_album = get_option('siteurl')."/members/".get_userdata($result[$j]->rt_user_id)->user_login."/media/video/";?>
                    <a href="<?php echo $url_to_album?>" title="">
                        <img src="<?php echo $list->objects[$i]->thumbnailUrl?>" alt="Thumb" />
                    </a>
	<?php

            }
        }
    }
	/***
	 * This is where you add your HTML and render what you want your widget to display.
	 */
	?>

	<?php echo $after_widget; ?>
<?php
}

/**
 * rt_media_widget_cool_widget_control()
 *
 * This function will enable a "edit" menu on your widget. This lets site admins click
 * the edit link on the widget to set options. The options you can then use in the display of
 * your widget.
 *
 * For example, in the groups component widget there is a setting called "max-groups" where
 * a user can define how many groups they would like to display.
 */
function rt_media_widget_cool_widget_control_video() {
	global $current_blog;

	$options = $newoptions = get_blog_option( $current_blog->blog_id, 'rt_media_widget_cool_widget_video');

	if ( $_POST['rt-bp-kaltura-widget-cool-widget-video'] ) {
		$newoptions['option_name'] = strip_tags( stripslashes( $_POST['rt-bp-kaltura-widget-cool-widget-option-video'] ) );
	}

	if ( $options != $newoptions ) {
		$options = $newoptions;
		echo update_blog_option( $current_blog->blog_id, 'rt_media_widget_cool_widget_video', $options );
	}
?>
<p>
    <label for="rt-bp-kaltura-widget-cool-widget-option-video">
            <?php _e( 'Max number of Videos to show:', 'rt-bp-kaltura' ); ?><br />
        <input class="widefat" id="rt-bp-kaltura-widget-cool-widget-option-video" name="rt-bp-kaltura-widget-cool-widget-option-video" type="text" value="<?php echo attribute_escape( $options['option_name'] ); ?>" style="width: 30%" />
    </label>
</p>
	<input type="hidden" id="rt-bp-kaltura-widget-cool-widget-video" name="rt-bp-kaltura-widget-cool-widget-video" value="1" />

<?php
}
?>